@Program for generating simulation results in Tables 1 and 3@;
#lineson;
output file = mpc_dfh reset;

lp=1000;@replications@;

@Procedure to calculate the log of the determinant of the covariance
matrix of the stacked steps-ahead forecast errors@;
@Calculates h dim. vector from 2 lp by h matrices of forecast errors@;
PROC (1) = invt(x,y,lp);
LOCAL f,sum,i,s,steph,invar,lp;
   invar=zeros(20,1);

steph=1;
do while steph<=20;
   f=0;
   sum=zeros(2*steph,2*steph);
   i=1;
      do while i<=lp;
      s=1;
          do while s<=steph;
          f=f|x[i,s]|y[i,s];
          s=s+1;
          endo;
      f=f[2:2*steph+1,.]; @getting rid of initialisation zero@;
      sum=sum+f*f';
      i=i+1;
      f=0;
      endo;
sum=sum*(1/lp);
   invar[steph,1]=(det(sum))^(1/steph);
   steph=steph+1;
 endo;

RETP(invar);
ENDP;

@Procedure to calculate the determinants of forecast error covariance
matrices (non-stacked)@;
@Calculates h dim. vector from 2 lp by h matrices of forecast errors@;
PROC (1) = deter(x,y,lp);
LOCAL steph,dete,lp;

dete=zeros(20,1);
steph=1;
do while steph<=20;
dete[steph,1]=(1/(lp*lp))*((x[.,steph]'x[.,steph])*(y[.,steph]'y[.,steph])
-(x[.,steph]'y[.,steph])*(x[.,steph]'y[.,steph]));
steph=steph+1;
endo;
RETP(dete);
ENDP;

@Procedure to calculate TMSFEs@;
@Calculates h dim. vector from 2 lp by h matrices of forecast errors@;
PROC (1) = TMSFE(x,y,lp);
LOCAL TMSFE, steph;

TMSFE=zeros(20,1);
steph=1;
do while steph<=20;
TMSFE[steph,1]=(1/lp)*( x[.,steph]'x[.,steph] + y[.,steph]'y[.,steph] );
steph=steph+1;
endo;
RETP(TMSFE);
ENDP;

@Procedure to calculate TMSFESE@;
@TMSFE MCSEs @;
@Calculates h dim. vector from 2 lp by h matrices of forecast errors@;
PROC (1) = TMSFESE(x,y,lp);
LOCAL SD, steph, TM, sumst, ii;

SD=zeros(20,1);
steph=1;
TM=TMSFE(x,y,lp);

do while steph<=20;

sumst=0;
ii=1;
do while ii<lp+1;
sumst=sumst+(x[ii,steph]*x[ii,steph]+y[ii,steph]*y[ii,steph])^2;
ii=ii+1;
endo;

SD[steph,1] = sqrt(  ((1/lp)*sumst - TM[steph,1]^2)/lp  );
steph=steph+1;
endo;
RETP(SD);
ENDP;

@Procedure main@;
PROC (0) = mainpr(lp,nd,rho,s,a10,a20,a11,a22,lamda,estc,mlrest,seed1);
     @estc=1 signals that constants are to be estimatesd@;
     @mlrest=1 signals that constant to be restricted for ML@;
LOCAL pye,pye1,om,om1,
      MSEeg,DMSEeg,ddeg,MSEuv,DMSEuv,dduv,MSED0,DMSED0,
      ddD0,MSEml,DMSEml,ddml,mclev,mcco,mcdifx,mcdify,analev,anaco,
      anadifx,anadify,
      segx,segy,suvx,suvy,sD0x,sD0y,smlx,smly,sxdag,sydag,dsegx,dsegy,
      dsuvx,dsuvy,dsD0x,dsD0y,dsmlx,dsmly,difdagx,difdagy,egcoint,uvcoint,
      D0coint,mlcoint,codag,uvx,uvy,egx,egy,D0x,D0y,mlx,mly,xdag,ydag,y,x,
      rv,rv1,rv2,
      e1,e2,
      bhat,res,Dx,Dy,bxeg,byeg,
      xy1,bxuv,byuv, bxd0,byd0,
      z,z1,dz,soot,skkt,skot,wa,c,wb,seigvec,seigva,eigorig,alpha,pie1,mlconst,
      j,g,p,m,iter,i,
      vanaly,vanaly1,vanaly2,piopi,piopi1,piopi2,
      beta,
      reu,rem,rud0,rmd0,rI0eu,rI0em,rI0ud0,rI0md0,rddeu,rddem,rddud0,rddmd0,
      f1,
      ecdb,uvdb,mldb,D0db,mcd,eudb,emdb,uD0db,mD0db,
      mccont,
      n,
      anw,mcw,mcdif,anadif;



@DGP in form Y(t)=Pye*Y(t-1) + const. + error, for calculating analytic forecast
error variance when true parameters are used@;
Pye=zeros(2,2);
Pye[1,1]=1+a11;
Pye[1,2]=-a11*lamda;
Pye[2,1]=a22;
Pye[2,2]=1-a22*lamda;

@DGP in form of coint. combination and differenced y @;    @?@;
Pye1=zeros(2,2);
pye1[1,1]=1+a11-lamda*a22;                                 @?@;
pye1[2,1]=a22;                                             @?@;

@Disturbance covariance matrix for levels@;
Om=zeros(2,2);
Om[1,1]=1;
Om[1,2]=rho*s;
Om[2,1]=rho*s;
Om[2,2]=s*s;

@Disturbance covariance matrix for coint. comb. and differenced y @;  @?@;
Om1=zeros(2,2);
om1[1,1]=1+lamda*lamda*s*s-2*lamda*rho*s;                             @?@;
om1[1,2]=rho*s-lamda*s*s;                                             @?@;
om1[2,1]=om1[1,2];
om1[2,2]=s*s;                                                         @?@;


MSEeg=zeros(20,1);
DMSEeg=zeros(20,1);
ddeg=zeros(20,1);

MSEuv=zeros(20,1);
DMSEuv=zeros(20,1);
dduv=zeros(20,1);

MSED0=zeros(20,1);
DMSED0=zeros(20,1);
ddD0=zeros(20,1);

MSEml=zeros(20,1);
DMSEml=zeros(20,1);
ddml=zeros(20,1);

mclev=zeros(20,1);
mcco=zeros(20,1);
mcdifx=zeros(20,1);
mcdify=zeros(20,1);
analev=zeros(20,1);
anaco=zeros(20,1);
anw=zeros(20,1);
anadifx=zeros(20,1);
anadify=zeros(20,1);
anadif=zeros(20,1);

@Forecast errors using EG, UV, D0, ML and true parameters@;

@Levels of x and y@;

segx=zeros(lp,20);
segy=zeros(lp,20);
suvx=zeros(lp,20);
suvy=zeros(lp,20);
sD0x=zeros(lp,20);
sD0y=zeros(lp,20);
smlx=zeros(lp,20);
smly=zeros(lp,20);
sxdag=zeros(lp,20);
sydag=zeros(lp,20);

@Levels of Dx and Dy@;

dsegx=zeros(lp,20);
dsegy=zeros(lp,20);
dsuvx=zeros(lp,20);
dsuvy=zeros(lp,20);
dsD0x=zeros(lp,20);
dsD0y=zeros(lp,20);
dsmlx=zeros(lp,20);
dsmly=zeros(lp,20);
difdagx=zeros(lp,20);
difdagy=zeros(lp,20);

@Coint. Combinations@;

egcoint=zeros(lp,20);
uvcoint=zeros(lp,20);
D0coint=zeros(lp,20);
mlcoint=zeros(lp,20);
codag=zeros(lp,20);

@**************************************************************************@;
iter=1;
    @******Iteration begins*****@;
    do until iter>lp;
  n=nd;  @reset n for each replication, since during the rep. it is reduced
          as initial observations are discarded@;

@matrices to contain 1..20 step-ahead forecasts@;
uvx=zeros(20,1);
uvy=zeros(20,1);        
egx=zeros(20,1);
egy=zeros(20,1);
D0x=zeros(20,1);
D0y=zeros(20,1);
mlx=zeros(20,1);
mly=zeros(20,1);
xdag=zeros(20,1);
ydag=zeros(20,1);


       y=zeros(n,1);x=zeros(n,1);
rv=rndns(2*n,1,seed1);
rv1=rv[1:n,1];
rv2=rv[n+1:2*n,1];


    @Generating psuedo random numbers with desired covariance matrix@;
e1=rv1;
e2=rho*s*rv1+sqrt(s*s*(1-rho*rho))*rv2;
@covariance matrix is then
1      rho*s
rho*s  s*s   @;

    @DGP@;
       x[1,1]=a10+e1[1,1];
       y[1,1]=a20+e2[1,1];
            i=2;
            do until i>n;
   @***********Simulating variables*****************@;
 x[i,1]=x[i-1,1]+a10+a11*(x[i-1,1]-lamda*y[i-1,1])+e1[i,1];

 y[i,1]=y[i-1,1]+a20+a22*(x[i-1,1]-lamda*y[i-1,1])+e2[i,1];
      i=i+1;
           endo;
  @x and y are n=nd dimension vectors, thus include discards. Discard first
  20 obs. and reduce n accordingly@;
x=x[21:n,1];
y=y[21:n,1];
n=n-20;


@ESTIMATION@;
   @***********EG First step*************@;
          @ x= by+error  @;
            bhat=invpd(y[1:n-20,1]'y[1:n-20,1])*y[1:n-20,1]'x[1:n-20,1];
            res=x-bhat*y;

   @***********EG Second step: OLS on each equation inc. residual from
   the first************@;
   Dx=x[2:n-20,1]-x[1:n-20-1,1];
   Dy=y[2:n-20,1]-y[1:n-20-1,1];
          @ Dx = bx. res + (constant+) error, similarly for Dy.@;

if estc==0;
   bxeg=invpd(res[1:n-20-1,1]'res[1:n-20-1,1])*res[1:n-20-1,1]'dx;
   byeg=invpd(res[1:n-20-1,1]'res[1:n-20-1,1])*res[1:n-20-1,1]'dy;
else;
   bxeg=invpd( (res[1:n-20-1,1]~ones(n-20-1,1))'
               (res[1:n-20-1,1]~ones(n-20-1,1)))*
               (res[1:n-20-1,1]~ones(n-20-1,1))'dx;
   byeg=invpd( (res[1:n-20-1,1]~ones(n-20-1,1))'
               (res[1:n-20-1,1]~ones(n-20-1,1)))*
               (res[1:n-20-1,1]~ones(n-20-1,1))'dy;
endif;

if estc==0;
   bxeg=bxeg|zeros(1,1);
   byeg=byeg|zeros(1,1);
endif;


   @***UVAR, OLS eqn. by eqn.**@;
        @x = bxuv1 x(-1) +  bxuv2 y(-1)  (+constant) @;
        @y = byuv1 x(-1) +  byuv2 y(-1)  (+constant) @;

if estc==0;
   xy1=x[1:n-20-1,1]~y[1:n-20-1,1];
else;
   xy1=x[1:n-20-1,1]~y[1:n-20-1,1]~ones(n-20-1,1);
endif;

   bxuv=invpd(xy1'xy1)*xy1'x[2:n-20,1];
   byuv=invpd(xy1'xy1)*xy1'y[2:n-20,1];

if estc==0;
   bxuv=bxuv|zeros(1,1);
   byuv=byuv|zeros(1,1);
endif;


   @***DVAR, No explanatory variables (other than a constant) D0**@;
   @NB. The DVAR is not correctly specified@;
        @Dx = (constant+) error@;
        @Dy = (constant+) error@;
if estc==0;
   bxd0=0;
   byd0=0;
else;
   bxd0=meanc(Dx);
   byd0=meanc(Dy);
endif;

   @Johansen ML procedure: no differences r=1@;
z=x~y;
z1=z[1:n-20-1,.];
dz=z[2:n-20,.]-z[1:n-20-1,.];

if estc==0;
soot=(dz[.,1]~dz[.,2])'(dz[.,1]~dz[.,2]);
skkt=(z1[.,1]~z1[.,2])'(z1[.,1]~z1[.,2]);
skot=(z1[.,1]~z1[.,2])'(dz[.,1]~dz[.,2]);

else;
     if mlrest==0;

soot=( (dz[.,1]-meanc(dz[.,1]))~(dz[.,2]-meanc(dz[.,2])) )'
( (dz[.,1]-meanc(dz[.,1]))~(dz[.,2]-meanc(dz[.,2])) );

skkt=( (z1[.,1]-meanc(z1[.,1]))~(z1[.,2]-meanc(z1[.,2])) )'
( (z1[.,1]-meanc(z1[.,1]))~(z1[.,2]-meanc(z1[.,2])) );

skot=( (z1[.,1]-meanc(z1[.,1]))~(z1[.,2]-meanc(z1[.,2])) )'
( (dz[.,1]-meanc(dz[.,1]))~(dz[.,2]-meanc(dz[.,2])) );

     else;
z1=z[1:n-20-1,.]~ones(n-20-1,1);
soot=dz'dz;
skkt=z1'z1;
skot=z1'dz;
     endif;

endif;

soot=soot/(n-20-1);
skot=skot/(n-20-1);
skkt=skkt/(n-20-1);

wa=chol(skkt);
c=wa';
wb = inv(c)*skot*inv(soot)*skot'inv(c');
{seigva,seigvec}=eigrs2(wb);
if mlrest==0;
seigvec=seigvec[.,2 1];
else;
seigvec=seigvec[.,3 2 1];
endif;
eigorig = inv(c')*seigvec;
alpha=-1*skot'eigorig;
pie1=alpha[.,1]*eigorig[.,1]';

@Calculation of constant term@;
if estc==0;
mlconst=zeros(2,1);
else;
  if mlrest==0;
    mlconst=meanc(dz+z1*pie1');
  else;
    mlconst=-pie1[.,3];
  endif;
endif;

@FORECASTING@;
@set up  20x1 matrix to contain the forecasts, for a particular
number of steps-ahead forecaster. @;
@***************************@;


uvx[1,1]=bxuv[1,1]*x[n-20,1]+bxuv[2,1]*y[n-20,1]+bxuv[3,1];
uvy[1,1]=byuv[1,1]*x[n-20,1]+byuv[2,1]*y[n-20,1]+byuv[3,1];

egx[1,1]=x[n-20,1]+bxeg[1,1]*(x[n-20,1]-y[n-20,1]*bhat)+bxeg[2,1];
egy[1,1]=y[n-20,1]+byeg[1,1]*(x[n-20,1]-y[n-20,1]*bhat)+byeg[2,1];

mlx[1,1]=x[n-20,1]-pie1[1,1]*x[n-20,1]-pie1[1,2]*y[n-20,1]+mlconst[1,1];
mly[1,1]=y[n-20,1]-pie1[2,1]*x[n-20,1]-pie1[2,2]*y[n-20,1]+mlconst[2,1];

D0x[1,1]=x[n-20,1]+bxd0;
D0y[1,1]=y[n-20,1]+byd0;

xdag[1,1]=x[n-20,1]+a10+a11*(x[n-20,1]-lamda*y[n-20,1]);
ydag[1,1]=y[n-20,1]+a20+a22*(x[n-20,1]-lamda*y[n-20,1]);

j=2;
  do until j>20 ; 


uvx[j,1]=bxuv[1,1]*uvx[j-1,1]+bxuv[2,1]*uvy[j-1,1]+bxuv[3,1];
uvy[j,1]=byuv[1,1]*uvx[j-1,1]+byuv[2,1]*uvy[j-1,1]+byuv[3,1];

egx[j,1]=egx[j-1,1]+bxeg[1,1]*(egx[j-1,1]-egy[j-1,1]*bhat)+bxeg[2,1];
egy[j,1]=egy[j-1,1]+byeg[1,1]*(egx[j-1,1]-egy[j-1,1]*bhat)+byeg[2,1];

mlx[j,1]=mlx[j-1,1]-pie1[1,1]*mlx[j-1,1]-pie1[1,2]*mly[j-1,1]+mlconst[1,1];
mly[j,1]=mly[j-1,1]-pie1[2,1]*mlx[j-1,1]-pie1[2,2]*mly[j-1,1]+mlconst[2,1];

D0x[j,1]=D0x[j-1,1]+bxd0;
D0y[j,1]=D0y[j-1,1]+byd0;

xdag[j,1]=xdag[j-1,1]+a10+a11*(xdag[j-1,1]-lamda*ydag[j-1,1]);
ydag[j,1]=ydag[j-1,1]+a20+a22*(xdag[j-1,1]-lamda*ydag[j-1,1]);


j=j+1;
  endo;


@Calc. sample covariance matrix of the forecast errors for each step ahead @;
@MSEeg is a 20x1 matrix, as is MSEuv, and the
rows contain the traces of the sample covariance matrices of forecast
errors for each step ahead.
SMSE is the MC estimates, ie. averaging over replications@;

p=1;   @loops over step ahead forecasts@;
do while p<21;

@The rows  of segx etc. correspond to the replication, the columns contain the
step-ahead values, of the forecast errors@;
 @LEVELS@;
         segx[iter,p]=x[p+n-20,1]-egx[p,1];
         segy[iter,p]=y[p+n-20,1]-egy[p,1];
         suvx[iter,p]=x[p+n-20,1]-uvx[p,1];
         suvy[iter,p]=y[p+n-20,1]-uvy[p,1];
         sD0x[iter,p]=x[p+n-20,1]-D0x[p,1];
         sD0y[iter,p]=y[p+n-20,1]-D0y[p,1];
         smlx[iter,p]=x[p+n-20,1]-mlx[p,1];
         smly[iter,p]=y[p+n-20,1]-mly[p,1];

@Forecast errors using forecasts generated with the true parameter values:
                                                             Control Variates@;
         sxdag[iter,p]=x[p+n-20,1]-xdag[p,1];
         sydag[iter,p]=y[p+n-20,1]-ydag[p,1];

 @COINT. COMBS.@;
@Forecast errors of the true cointegrating combinations @;
         egcoint[iter,p]=segx[iter,p]-lamda*segy[iter,p];
         uvcoint[iter,p]=suvx[iter,p]-lamda*suvy[iter,p];
         D0coint[iter,p]=sD0x[iter,p]-lamda*sD0y[iter,p];
         mlcoint[iter,p]=smlx[iter,p]-lamda*smly[iter,p];

@Forecast error in TRUE cointegrating combination using true parameter
values to generate the forecasts@;
         codag[iter,p]=sxdag[iter,p]-lamda*sydag[iter,p];

 @DIFFERENCES@;
   if p==1;
@Forecast errors in Dx and Dy@;
         dsegx[iter,p]=segx[iter,p];
         dsegy[iter,p]=segy[iter,p];
         dsuvx[iter,p]=suvx[iter,p];
         dsuvy[iter,p]=suvy[iter,p];
         dsD0x[iter,p]=sD0x[iter,p];
         dsD0y[iter,p]=sD0y[iter,p];
         dsmlx[iter,p]=smlx[iter,p];
         dsmly[iter,p]=smly[iter,p];

@Forecast errors in Dx and Dy using true parameter values@;
         difdagx[iter,p]=sxdag[iter,p];
         difdagy[iter,p]=sydag[iter,p];

   else;

         dsegx[iter,p]=segx[iter,p]-segx[iter,p-1];
         dsegy[iter,p]=segy[iter,p]-segy[iter,p-1];
         dsuvx[iter,p]=suvx[iter,p]-suvx[iter,p-1];
         dsuvy[iter,p]=suvy[iter,p]-suvy[iter,p-1];
         dsD0x[iter,p]=sD0x[iter,p]-sD0x[iter,p-1];
         dsD0y[iter,p]=sD0y[iter,p]-sD0y[iter,p-1];
         dsmlx[iter,p]=smlx[iter,p]-smlx[iter,p-1];
         dsmly[iter,p]=smly[iter,p]-smly[iter,p-1];

         difdagx[iter,p]=sxdag[iter,p]-sxdag[iter,p-1];
         difdagy[iter,p]=sydag[iter,p]-sydag[iter,p-1];

   endif;
        
p=p+1;
endo;


iter=iter+1;
endo;

         g=1;
         do while g<21;
@sxdag and sydag are the MC control variates for the levels, codag for the
coint. combination, and difdagx and difdagy for the differences@;

@Calculating analytical term of forecast error variance using the
true parameters@;

@Om is the disturbance matrix for the levels, Om1 for the coint.     @?@;
combination and Dy, and Om2 for the differences. @;                  @?@;

      vanaly=Om;
      vanaly1=Om1;

  if g>1;
      piopi=Om;
      piopi1=Om1;
      m=2;
        do while m<=g;
         piopi=Pye*piopi*Pye';
         piopi1=Pye1*piopi1*Pye1';
         vanaly=vanaly+piopi;
         vanaly1=vanaly1+piopi1;
        m=m+1;
        endo;
  endif;

@Analytic variances for differences@;
vanaly2=zeros(2,2);
 if g>1;
 piopi2=pye*om*pye'-pye*om-om*pye'+om;
 vanaly2=pye*om*pye'-pye*om-om*pye'+om;
m=3;
do while m<=g;
piopi2=pye*piopi2*pye';
vanaly2=vanaly2+piopi2;
m=m+1;
endo;
 endif;
vanaly2=vanaly2+om;

analev[g,1]=vanaly[1,1]+vanaly[2,2];
anadify[g,1]=vanaly1[2,2];
anaco[g,1]=vanaly1[1,1];
anadifx[g,1]=vanaly2[1,1];
anw[g,1]=anaco[g,1]+anadify[g,1];
anadif[g,1]=anadifx[g,1]+anadify[g,1];

g=g+1;
endo;


@MC estimate of the forecast error variance using the true parameters@;
mclev=TMSFE(sxdag,sydag,lp);
mcw=TMSFE(codag,difdagy,lp);
mcdif=TMSFE(difdagx,difdagy,lp);


@Trace of levels@;
mseeg=TMSFE(segx,segy,lp)-mclev+analev;
mseuv=TMSFE(suvx,suvy,lp)-mclev+analev;
mseD0=TMSFE(sD0x,sD0y,lp)-mclev+analev;
mseml=TMSFE(smlx,smly,lp)-mclev+analev;

@Trace of Dy and coint. combinations@;
dmseeg=TMSFE(egcoint,dsegy,lp)-mcw+anw;
dmseuv=TMSFE(uvcoint,dsuvy,lp)-mcw+anw;
dmseD0=TMSFE(D0coint,dsD0y,lp)-mcw+anw;
dmseml=TMSFE(mlcoint,dsmly,lp)-mcw+anw;

@Trace of differences@;
ddeg=TMSFE(dsegx,dsegy,lp)-mcdif+anadif;
dduv=TMSFE(dsuvx,dsuvy,lp)-mcdif+anadif;
ddD0=TMSFE(dsD0x,dsD0y,lp)-mcdif+anadif;
ddml=TMSFE(dsmlx,dsmly,lp)-mcdif+anadif;




reu=100*mseeg./mseuv;
rem=100*mseeg./mseml;
rud0=100*mseuv./mseD0;
rmd0=100*mseml./mseD0;

rI0eu=100*dmseeg./dmseuv;
rI0em=100*dmseeg./dmseml;
rI0ud0=100*dmseuv./dmseD0;
rI0md0=100*dmseml./dmseD0;

rddeu=100*ddeg./dduv;
rddem=100*ddeg./ddml;
rddud0=100*dduv./ddD0;
rddmd0=100*ddml./ddD0;

@format /rd 6,2@;
format /rd 6,2;


"****************************TRACE******************************************";
"First 4 columns all adjusted for control variates";
" ";
"                           Table 1A. Levels.                             ";
" ";
"   EC     UV     ML     D0   EG/UV  EG/ML  UV/D0  ML/D0 Control_MC Control_AN";
mseeg~mseuv~mseml~mseD0~reu~rem~rud0~rmd0~mclev~analev;
" ";
"                           Standard Deviations: Naive                    ";
TMSFESE(segx,segy,lp)~TMSFESE(suvx,suvy,lp)~TMSFESE(smlx,smly,lp)~TMSFESE(sD0x,sD0y,lp)~TMSFESE(sxdag,sydag,lp);
" ";
" ";
"                           Table 3A.  The cointegrating combination and Dy.";
" ";
"  EGI(0) UVI(0) MLI(0) D0I(0) EG/UV EG/ML UV/D0  ML/D0 Control_MC Control_AN";
dmseeg~dmseuv~dmseml~dmseD0~rI0eu~rI0em~rI0ud0~rI0md0~mcw~anw;
" ";
"                           Standard Deviations: Naive                      ";
TMSFESE(egcoint,dsegy,lp)~TMSFESE(uvcoint,dsuvy,lp)~TMSFESE(mlcoint,dsmly,lp)~TMSFESE(D0coint,dsD0y,lp)~TMSFESE(codag,difdagy,lp);
" ";

"                           Table 4A.  Differences.                         ";
" ";
"  EGD(0) UVD(0) MLD(0) D0D(0) EG/UV EG/ML UV/D0  ML/D0 Control_MC Control_AN";
ddeg~dduv~ddml~ddD0~rddeu~rddem~rddud0~rddmd0~mcdif~anadif;
"  ";
"                           Standard Deviations: Naive                      ";
TMSFESE(dsegx,dsegy,lp)~TMSFESE(dsuvx,dsuvy,lp)~TMSFESE(dsD0x,dsD0y,lp)~TMSFESE(dsmlx,dsmly,lp)~TMSFESE(difdagx,difdagy,lp);
;

"****************************DETERMINANT (STACKED)*********************";
"NONE OF THESE ADJ. FOR CONTROL VARIATES. NO ANALYTIC VALUES CALCULATED";


ecdb=invt(segx,segy,lp);
uvdb=invt(suvx,suvy,lp);
mldb=invt(smlx,smly,lp);
D0db=invt(sD0x,sD0y,lp);
mcd=invt(sxdag,sydag,lp);
eudb=100*ecdb./uvdb;
emdb=100*ecdb./mldb;
uD0db=100*uvdb./D0db;
mD0db=100*mldb./D0db;
mccont=mcd;
" ";
"                           Table 1C. Levels.                             ";
" ";
"   EC     UV     ML     D0   EG/UV  EG/ML  UV/D0  ML/D0 Control_MC ";
ecdb~uvdb~mldb~D0db~eudb~emdb~ud0db~md0db~mcd;
"";


RETP;
ENDP;
@end of procedure MAINPR@;


 @EXPERIMENTS@;
seed1=3937842; @common random numbers across experiments@;
@arguments of proc MAINPR are lp,n,rho,s,a10,a20,a11,a22,lamda,estc,mlrest,seed1 @;

     nd=140;

"(4A).          rho=0, s=1, a10=0, a20=0, a11=-0.1, a22=0.25, lamda=1, estc=0. ";
Call mainpr(lp,nd,0,1,0,0,-0.1,0.25,1,0,0,seed1);


"(4B).          rho=0, s=1, a10=0, a20=0, a11=-0.1, a22=0.25, lamda=1, estc=1. ";
Call mainpr(lp,nd,0,1,0,0,-0.1,0.25,1,1,0,seed1);

     nd=90;


"(4A).          rho=0, s=1, a10=0, a20=0, a11=-0.1, a22=0.25, lamda=1, estc=0. ";
Call mainpr(lp,nd,0,1,0,0,-0.1,0.25,1,0,0,seed1);


"For restricting constants table";
"Sample 100"; nd=140;
"(1NR100).rho=0, s=1, a10=1, a20=-1, a11=-0.1, a22=0.25, lamda=1, estc=1, restr=0. ";
Call mainpr(lp,nd,0,1,1,-1,-0.1,0.25,1,1,0,seed1);

"(2NR100).rho=0, s=1, a10=1, a20=-2.5, a11=-0.1, a22=0.25, lamda=1, estc=1, restr=0. ";
Call mainpr(lp,nd,0,1,1,-2.5,-0.1,0.25,1,1,0,seed1);

"(2R100).rho=0, s=1, a10=1, a20=-2.5, a11=-0.1, a22=0.25, lamda=1, estc=1, restr=1. ";
Call mainpr(lp,nd,0,1,1,-2.5,-0.1,0.25,1,1,1,seed1);



system;
end;


